// template.cc -- This is a template file for writing radio drum programs.  
//
// Programmer:    John Bacon <carmelite@ccrma.stanford.edu>
// Creation Date: Mon Apr  8 13:50:42 PDT 1996
// Last Modified: Sun Apr 21 14:40:19 PDT 1996
// Filename:      /user/c/craig/lang/c/drum/template.cc
// Syntax:        C++ (Gnu C++ compiler: /Local/Unix/bin/g++)
// $Smake:        g++ -O -o %b %f -I../include -L../lib %
//                -ldrum -lmidi -loptions && strip %b
//                Type "../bin/smake FILENAME" to compile this file.
//

#include "main.cc"

/* In this file, define the behavior for these functions as necessary:
 *
 *    description:            short description of what program does
 *    programhelp:            explaination of radio drum variables
 *    initialization:         action to take at beginning of program
 *    mainloopalgorithms:     main loop actions of user
 *    stick1trig:             action after stick1 triggers
 *    stick2trig:             action after stick2 triggers
 *    b14plustrig:            action after b14+ button is pushed
 *    b15plustrig:            action after b15+ button is pushed
 *    stick1pollresponse:     action after stick1 returns a poll
 *    stick2pollresponse:     action after stick2 returns a poll
 *    potspollresponse:       action after pots return a poll
 *    cleanup:                action to take before exiting program
 */


/***************** Beginning of user functions ****************************/

/*---------------- Documentation functions -------------------------------*/

void description(void) {
   cout
   << "______________________________________________________________ \n"
   << "| Description:                                                |\n"
   << "|                                                             |\n"
   << "|                                                             |\n"
   << "|                                                             |\n"
   << "---------------------------------------------------------------\n"
   ;
}


void programhelp(void) {
   cout
   << ">                                                              \n"
   << "> Baton 1:                                                     \n"
   << ">    x1t:                                                      \n"
   << ">    y1t:                                                      \n"
   << ">    w1t:                                                      \n"
   << ">    x1p:                                                      \n"
   << ">    y1p:                                                      \n"
   << ">    z1p:                                                      \n"
   << "> Baton 2:                                                     \n"
   << ">    x2t:                                                      \n"
   << ">    y2t:                                                      \n"
   << ">    w2t:                                                      \n"
   << ">    x2p:                                                      \n"
   << ">    y2p:                                                      \n"
   << ">    z2p:                                                      \n"
   << ">                                                              \n"
   << ">    p1p:                                                      \n"
   << ">    p2p:                                                      \n"
   << ">    p3p:                                                      \n"
   << ">   +b14: Command mode.                                        \n"
   << ">   +b15: This help screen.                                    \n"
   << ">                                                              \n"
   ;
}

/*---------------- Initialization functions ------------------------------*/

void initialization(void) { description(); }

/*---------------- Main loop functions -----------------------------------*/

void mainloopalgorithms(void) { }

/*---------------- Trigger response functions ----------------------------*/

void stick1trig(void) { cout << "Baton 1 triggered\n"; }
void stick2trig(void) { cout << "Baton 2 triggered\n"; }
void b14plustrig(void) { cout << "B14+ triggered\n"; commandmode(); }
void b15plustrig(void) { cout << "B15+ triggered\n"; programhelp(); }

/*---------------- Poll response functions -------------------------------*/

void stick1pollresponse(void) { }
void stick2pollresponse(void) { }
void potspollresponse(void) { }

/*---------------- Actions to take just before leaving program -----------*/

void cleanup(void) { }

/***************** End of user functions **********************************/

