// hotcold2.cc -- Find the virtual point (not really the point anymore).
//
// Programmer:    Craig Stuart Sapp
// Class:         Music 120
// Creation Date: Tue Mar 19 13:35:34 PST 1996
// Last Modified: Tue Mar 19 20:59:18 PST 1996
// Filename:      /user/c/craig/class/120/project/hotcold2.cc
// Syntax:        C++ (Gnu C++ compiler)
// $Smake:        /user/c/craig/class/120/radio-baton/source/mk++ %f 
//    Type "/user/c/craig/bin/smake FILENAME" to compile this file.
//

#include "/user/c/craig/class/120/radio-baton/source/setup.h"
#include <iostream.h>
#include <math.h>


/***************** Beginning of user algorithms ***************************/

Baton rb;                           // interface to the baton

// for playing on Disklavier:
Note  xVoice(CH_1, 0);              // interface to the synthesizer
Note  yVoice(CH_1, 0);              // interface to the synthesizer
Note  zVoice(CH_1, 0);              // interface to the synthesizer

// for playing on Synthesizer with different timbres:
// Note  xVoice(CH_1, 0);           // interface to the synthesizer
// Note  yVoice(CH_2, 10);          // interface to the synthesizer
// Note  zVoice(CH_3, 40);          // interface to the synthesizer

int  xrand, yrand, zrand;           // random point in baton space
int  status = OFF;                  // test whether to play notes
long timer;                         // time how long it takes to find point

const int C7 = 108;                 // highest note 
const int A0 = 21;                  // lowest note

/*---------------- Initialization algorithms -----------------------------*/

void initialization(void) {
   rb.setPollRate(200);       // initial poll rate set to 200 milliseconds
   Description();
   xVoice.sendTimbre();
   yVoice.sendTimbre();
   zVoice.sendTimbre();
}

void Description(void) {
   cout
        << "______________________________________________________________ \n"
        << "| Description:                                                |\n"
        << "|    Hit the drum with baton 1 to start the search for        |\n"
        << "| a random point with baton 1.  Velocity of baton 1 determines|\n"
        << "| tempo of notes.  Closer you are to the random point, the    |\n"
        << "| higher all of the notes get.  If you find the point that    |\n"
        << "| the computer chose, the notes are turned off.               |\n"
        << "|                          -- Craig Stuart Sapp, 19 Mar 1996  |\n"
        << "---------------------------------------------------------------\n"
   ;
}

void ProgramHelp(void) {
   cout 
        << ">                                                              \n"
        << "> Baton 1:                                                     \n"
        << ">     1t: Start                                                \n"
        << ">    x1p: Pitch of voice 1                                     \n"
        << ">    y1p: Pitch of voice 2                                     \n"
        << ">    z1p: Pitch of voice 3                                     \n"
        << "> Baton 2: Nothing                                             \n"
        << ">                                                              \n"
        << ">    p1p: Amplitude of voice 1                                 \n"
        << ">    p2p: Amplitude of voice 2                                 \n"
        << ">    p3p: Amplitude of voice 3                                 \n"
        << ">   +b14: Return to command mode                               \n"
        << ">   +b15: This help screen                                     \n"
        << ">                                                              \n"
   ;
}


/*---------------- Main loop algorithms ----------------------------------*/

void mainloopalgorithms(void) {

   // determine the poll rate by checking the velocity of baton 1:
   rb.setPollRate((int)(1.5 * abs(200 - abs((int)(rb.baton1v())) * 5) + 10));

   // play notes if it is polling time:
   if (rb.checkPollTime() && status == ON) {
      rb.pollAll();
      if (rb.x1ps(A0, C7) != rb.x1pos(A0, C7)) 
         xVoice.play(C7-abs(xrand-rb.x1ps(A0, C7)), p1p);
      if (rb.y1ps(A0, C7) != rb.y1pos(A0, C7)) 
         yVoice.play(C7-abs(yrand-rb.y1ps(A0, C7)), p2p);
      if (rb.z1ps(A0, C7) != rb.z1pos(A0, C7)) 
         zVoice.play(C7-abs(zrand-rb.z1ps(A0, C7)), p3p);

      // if found random point, stop playing notes:
      if ( abs(rb.x1ps(A0, C7) - xrand) < 8    && 
           abs(rb.y1ps(A0, C7) - yrand) < 8    && 
           abs(rb.z1ps(A0, C7) - zrand) < 8         ) {

         status = OFF;
         xVoice.off(); 
         yVoice.off(); 
         zVoice.off();

         cout << "Time to find point: " << (t_time-timer)/1000.0
              << " seconds." << endl;
      }
   }
}


/*---------------- Triggered algorithms ----------------------------------*/

void stick1trig(void) {
   if (status == OFF) {
      status = ON;
      timer = t_time;
      xrand = rand() % (C7-A0) + A0;
      yrand = rand() % (C7-A0) + A0;
      zrand = (rand() % 44) + 44;        // low z values are too high
  
      cout << "Random point picked." << endl;
   }
}

void stick2trig(void) {
   cout << "Use baton 1" << endl;
}

void b14plustrig(void) {
   xVoice.off();
   yVoice.off();
   zVoice.off();
}

void b15plustrig(void) {
   ProgramHelp();
}

/*---------------- Poll response algorithms ------------------------------*/

void stick1pollresponse(void) { }
void stick2pollresponse(void) { }
void potspollresponse(void) { }


/***************** End of user algorithms *********************************/
